<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>file - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="file.html">file</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="file.html#.readDir">readDir</a></li><li data-type='method' style='display: none;'><a href="file.html#.getFileTime">getFileTime</a></li><li data-type='method' style='display: none;'><a href="file.html#.path">path</a></li><li data-type='method' style='display: none;'><a href="file.html#.exists">exists</a></li><li data-type='method' style='display: none;'><a href="file.html#.load">load</a></li><li data-type='method' style='display: none;'><a href="file.html#.save">save</a></li><li data-type='method' style='display: none;'><a href="file.html#.gnuplot">gnuplot</a></li></ul></li><li><a href="http.html">http</a></li><li><a href="python.html">python</a></li><li><a href="regex.html">regex</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="regex.html#.regexMatch">regexMatch</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexIndexes">regexIndexes</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexReplace">regexReplace</a></li><li data-type='method' style='display: none;'><a href="regex.html#.regexSplit">regexSplit</a></li></ul></li><li><a href="stats.html">stats</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="stats.html#.random">random</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStat">getStat</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getStatValue">getStatValue</a></li><li data-type='method' style='display: none;'><a href="stats.html#.getDivergence">getDivergence</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotHistogram">plotHistogram</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatCurve">plotStatCurve</a></li><li data-type='method' style='display: none;'><a href="stats.html#.plotStatBoxes">plotStatBoxes</a></li></ul></li><li><a href="std.html">std</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="std.html#.echo">echo</a></li><li data-type='method' style='display: none;'><a href="std.html#.alert">alert</a></li><li data-type='method' style='display: none;'><a href="std.html#.argv">argv</a></li><li data-type='method' style='display: none;'><a href="std.html#.system">system</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li><li data-type='method' style='display: none;'><a href="std.html#.wfork">wfork</a></li></ul></li><li><a href="time.html">time</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="time.html#.sleep">sleep</a></li><li data-type='method' style='display: none;'><a href="time.html#.now">now</a></li><li data-type='method' style='display: none;'><a href="time.html#.nowISO">nowISO</a></li></ul></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">file</h1>
    

    




<section>

<header>
    
        <h2>
        
            file
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="file"><span class="type-signature"></span>factory file<span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Specifies the file system specific functions.</p>
<ul>
<li>These functions are accessible via the <code>aidesys::</code> prefix.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id=".readDir"><span class="type-signature type-signature-static">(static) </span>readDir<span class="signature">(path, pattern<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Array.&lt;string>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Lists all files of a directory.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The directory to list.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>pattern</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>".*"</code>
                
                </td>
            

            <td class="description last"><p>The file pattern regular expression using the <a href="http://www.cplusplus.com/reference/regex/ECMAScript">ECMAScript syntax</a>.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A <code>std::vector&lt;std::string&gt;</code> structure with the file names.</p>
<ul>
<li>The file base names with file extension and without the directory path are provided.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array.&lt;string></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getFileTime"><span class="type-signature type-signature-static">(static) </span>getFileTime<span class="signature">(filename)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Gets the file last modificaton time, in milliseconds.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The file path name.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The file last modificaton time, in milliseconds, since January 1, 1970, midnight, UTC/GMT (i.e., Greewitch time).</p>
<ul>
<li>Returns NAN, if the file does not exists:
<ul>
<li>So: <code>std::isnan(aidesys::getFileTime(file))</code> is equivalent to <code>aidesys::exists(file)</code>.</li>
</ul>
</li>
</ul>
</div>



    



        
            

    

    <h4 class="name" id=".path"><span class="type-signature type-signature-static">(static) </span>path<span class="signature">(filename, what<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a filename path element.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The file path name.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>what</code></td>
            

            <td class="type">
            
                
<span class="param-type">char</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>'b'</code>
                
                </td>
            

            <td class="description last"><ul>
<li>'b' The base-name of the file without extension.</li>
<li>'f' The file base-name with the extension.</li>
<li>'e' The extension of the filename.</li>
<li>'d' The directory name of the filename.</li>
<li>'n' The normalized path name, resolving the <code>.</code> and <code>..</code> path elements, and multiple <code>/</code>.</li>
<li>'r' The real absolute normalized path name, taking system existing location into account.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The filename element.</p>
</div>



    



        
            

    

    <h4 class="name" id=".exists"><span class="type-signature type-signature-static">(static) </span>exists<span class="signature">(filename)</span><span class="type-signature"> &rarr; {bool}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Checks if a file exists.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The file path name.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>True if the file exists and is readable, false otherwise.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">bool</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".load"><span class="type-signature type-signature-static">(static) </span>load<span class="signature">(filename)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Loads a textual file.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The file path name.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The file contents as a string.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".save"><span class="type-signature type-signature-static">(static) </span>save<span class="signature">(filename, string)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Saves a textual file.</p>
<ul>
<li>The file directory is created, if required.</li>
<li>If the file already exists, a backup of name <code>filename~</code> is created.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>filename</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The file path name.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>string</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The file contents as a string.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id=".gnuplot"><span class="type-signature type-signature-static">(static) </span>gnuplot<span class="signature">(file, plot, data<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Generated a gnuplot interface display script.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>file</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The related data file name (without extension). By contract,</p>
<ul>
<li>the file basename is used as the plot title;</li>
<li>the display script is generated in <code>$file.gnuplot.sh</code>.</li>
<li>the plot image is generated in <code>$file.png</code>.</li>
<li>the data is stored in a <code>$file.dat</code>.</li>
</ul>
<p>To display the gnuplot, run <code>$file.gnuplot.sh</code>.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>plot</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The gnuplot display commands.</p>
<ul>
<li>see: <a href="http://gnuplot.sourceforge.net/docs_4.2/node154.html">gnuplot set commands</a>.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>data</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>""</code>
                
                </td>
            

            <td class="description last"><p>An optional string with the plot data.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>